Name:           nextcloud

%define prerelease %nil
%define base_version 15.0.0

Version:       	%{base_version}
%define nc_version %{base_version}
Release:        1.1

Url:            http://www.nextcloud.org
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
BuildArch:      noarch
Summary:        The server - private file sync and share server
License:        AGPL-3.0 and MIT
Group:          Productivity/Networking/Web/Utilities
Source100:	apache_conf_default

Requires:	%{name}-deps  >= %{nc_version}
Requires:	%{name}-files >= %{nc_version}

%description
ownCloud Server provides you a private file sync and share
cloud. Host this server to easily sync business or private documents
across all your devices, and share those documents with other users of
your ownCloud server on their devices.

%define statedir	/var/run

%define apache_serverroot /var/www
%define apache_confdir /etc/httpd/conf.d
%define nc_user apache
%define nc_group apache
%define __jar_repack 0
%define nc_apache_web_dir 	%{apache_serverroot}/nextcloud

%define nc_dir		%{nc_apache_web_dir}
%define nc_config_dir 	%{nc_apache_web_dir}/config
%define nc_data_dir 	%{nc_apache_web_dir}/data
%define nc_data_pdir 	%{nc_apache_web_dir}

%define ncphp		php
%define ncphp_bin	/usr/bin
%define ncphp_deps_name	%{name}-deps-php5
%define nchttpd		httpd

#####################################################

%package -n %{ncphp_deps_name}
Provides: %{name}-deps
Requires:       curl
Requires:	%{ncphp}-ldap
Requires:       %{nchttpd}
Requires:       sqlite
Requires:       %{ncphp}-mysql
Requires:       %{ncphp} >= 5.4.0
Requires:       %{ncphp}-json %{ncphp}-mbstring %{ncphp}-process %{ncphp}-xml %{ncphp}-zip
Requires:	%{ncphp}-posix %{ncphp}-gd
Requires:	policycoreutils-python
Requires:       %{ncphp}-pdo
Summary: Dependencies for php5
%description -n %{ncphp_deps_name}
%{summary}.

#####################################################

%prep
# setup -q -n nextcloud

%build
echo build

%install
%define nc_docdir_base /usr/share/lib
%define nc_docdir %{nc_docdir_base}/%{name}-%{base_version}
mkdir -p $RPM_BUILD_ROOT/%{apache_confdir}/
sed -e 's@/var/www/nextcloud@%{nc_dir}@' < %{SOURCE100} > $RPM_BUILD_ROOT/%{apache_confdir}/nextcloud.conf
echo install

%clean
rm -rf "$RPM_BUILD_ROOT"

%pre -n %{ncphp_deps_name}
if [ $1 -eq 1 ]; then
    echo "%{name} pre-install: First install starting"
else
    echo "%{name} pre-install: installing upgrade ..."
fi
if [ -x %{ncphp_bin}/php -a -s %{nc_dir}/config/config.php ]; then
  echo "%{name} pre-install: occ maintenance:mode --on"
  su %{nc_user} -s /bin/sh -c "cd %{nc_dir}; PATH=%{ncphp_bin}:$PATH php ./occ maintenance:mode --on" || true
  echo yes > %{statedir}/occ_maintenance_mode_during_nextcloud_install
fi

%post -n %{ncphp_deps_name}
if [ ! -s %{statedir}/need_apache_reload_after_nextcloud_install ]; then	
  (service %{nchttpd} status | grep running > %{statedir}/need_apache_reload_after_nextcloud_install) || true
fi

if [ -s %{statedir}/need_apache_reload_after_nextcloud_install ]; then
  echo "%{name} post-install: apache: Reloading"
  service %{nchttpd} status && service %{nchttpd} reload || service %{nchttpd} start || true
fi
rm -f %{statedir}/need_apache_reload_after_nextcloud_install

if [ -s %{statedir}/occ_maintenance_mode_during_nextcloud_install ]; then
    echo  "Leaving server in maintenance mode. Please run occ upgrade manually."
    echo  ""
    echo  "See https://doc.nextcloud.org/server/9.0/admin_manual/maintenance/upgrade.html"
    echo  ""
fi
rm -f %{statedir}/occ_maintenance_mode_during_nextcloud_install

if [ $1 -eq 1 ]; then
    echo "Asserting file permission during first install"
    chown -R %{nc_user}:%{nc_group} %{nc_config_dir} %{nc_data_dir} %{nc_dir}/apps || true
fi


# no binary packages are generated without a files section.
%files
%files -n %{ncphp_deps_name}
%config(noreplace) %{apache_confdir}/nextcloud.conf

%changelog
* Sun Mar 26 2017 Benjamin Rose <benrose@math.princeton.edu>
- Update to version 11.0.2

* Sat Aug 27 2016 Benjamin Rose <benrose@math.princeton.edu>
- Initial packaging of NextCloud, version 10.0.0
